[LeetCode-24]Convert Sorted List to Binary Search Tree
It is similar with "Convert Sorted Array to Binary Search Tree". But the difference here is we have no way to random access item in O(1). If we build BST from array, we can build it from top to bottom, like 1. choose the middle one as root, 2. build left sub BST 3. build right sub BST 4. do this recursively. But for linked list, we can't do that because Top-To-Bottom are heavily relied on the index operation. There is a smart solution to provide an Bottom-TO-Top as an alternative way, http://leetcode.com/2010/11/convert-sorted-list-to-balanced-binary.html With this, we can insert nodes following the list’s order. So, we no longer need to find the middle element, as we are able to traverse the list while inserting nodes to the tree.
c++
TreeNode *sortedListToBST(ListNode *head) {
int len = 0;
ListNode *p = head;
while(p){
len++;
p = p->next;
}
return buildBST(head, 0, len-1);
}
TreeNode *buildBST(ListNode *& head, int start, int end){
if(start > end) return NULL;
int mid = (start + end)/2;
TreeNode *leftNode = buildBST(head, start, mid-1);
TreeNode *parent = new TreeNode(head->val);
parent->left = leftNode;
head = head->next;
parent->right = buildBST(head, mid+1, end);
return parent;
}
java
public class Solution {
public class Element{
ListNode n;
TreeNode t;
public Element(ListNode listNode, TreeNode treeNode){
this.n = listNode;
this.t = treeNode;
}
}
public TreeNode sortedListToBST(ListNode head) {
int len = 0;
ListNode pNode = head;
while(pNode!=null){
len++;
pNode = pNode.next;
}
return buildBST(head, 0, len-1).t;
}
public Element buildBST(ListNode head, int start, int end){
if(start>end) return new Element(head, null);
int middle = (start+end)/2;
Element left = buildBST(head, start, middle-1);
head = left.n;
TreeNode rootNode = new TreeNode(head.val);
rootNode.left = left.t;
head = head.next;
Element right = buildBST(head, middle+1, end);
rootNode.right = right.t;
return new Element(right.n, rootNode);
}
}
같은 알고리즘이 만약에 자바로 실현된다면 함수는 값 전달이기 때문에 전달을 인용할 수 없기 때문에head는 호출 과정에서 뒤로 가지 않고 그에 상응하는listnode와treenode를 저장해야 한다.
이 내용에 흥미가 있습니까?
현재 기사가 여러분의 문제를 해결하지 못하는 경우 AI 엔진은 머신러닝 분석(스마트 모델이 방금 만들어져 부정확한 경우가 있을 수 있음)을 통해 가장 유사한 기사를 추천합니다:
python 문자열 입력으로 모든 유효한 IP 주소 생성(LeetCode 93번 문제)이 문제의 공식 난이도는 Medium으로 좋아요 1296, 반대 505, 통과율 35.4%를 눌렀다.각 항목의 지표로 말하자면 보기에는 약간 규범에 맞는 것 같지만, 실제로도 확실히 그렇다.이 문제의 해법과 의도는 ...
텍스트를 자유롭게 공유하거나 복사할 수 있습니다.하지만 이 문서의 URL은 참조 URL로 남겨 두십시오.
CC BY-SA 2.5, CC BY-SA 3.0 및 CC BY-SA 4.0에 따라 라이센스가 부여됩니다.